
import 'package:flutter/material.dart';
import 'package:rapid_widgets_library/widget-classesUsed.dart';
class ContactCardWidget extends StatefulWidget {
  final ContactCardParameters  cardParameters;
   ContactCardWidget({Key key, this.cardParameters}) : super(key: key);

  @override
  _ContactCardWidgetState createState() => _ContactCardWidgetState();
}

class _ContactCardWidgetState extends State<ContactCardWidget> {
  @override
  Widget build(BuildContext context) {
    return Padding(
      padding:  EdgeInsets.only(
        left:   widget.cardParameters.paddingLeft!=null?widget.cardParameters.paddingLeft:0,
        right:  widget.cardParameters.paddingRight!=null?widget.cardParameters.paddingRight:0,
        top:    widget.cardParameters.paddingTop!=null?widget.cardParameters.paddingTop:0,
        bottom:  widget.cardParameters.paddingBoottom!=null?widget.cardParameters.paddingBoottom:0,
      ),
      child: Column(
        mainAxisSize: MainAxisSize.min,
        children: [
          Card(
            color: widget.cardParameters.backgroundColorOuterCard??Colors.white,
            elevation: widget.cardParameters.elevation!=null?widget.cardParameters.elevation:2,
            shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(widget.cardParameters.borderRadius!=null?widget.cardParameters.borderRadius:10)),
            child:  (widget.cardParameters.imgePostition=="Up")?
            Column(
              children: [
                Padding(
                  padding:  EdgeInsets.fromLTRB(
                      widget.cardParameters.imagePaddingLeft!=null? widget.cardParameters.imagePaddingLeft:0,
                      widget.cardParameters.imagePaddingTop!=null? widget.cardParameters.imagePaddingTop:0,
                      widget.cardParameters.imagePaddingRight!=null? widget.cardParameters.imagePaddingRight:0,
                    widget.cardParameters.imagePaddingBoottom!=null? widget.cardParameters.imagePaddingBoottom:0,
                  ),
                  child: (widget.cardParameters.cirleAvatar)?
                  CircleAvatar(
                    backgroundImage: NetworkImage( widget.cardParameters.urlImage!='null'?
                    widget.cardParameters.urlImage:'https://fujifilm-x.com/wp-content/uploads/2019/08/xc16-50mmf35-56-ois-2_sample-images02.jpg'),
                    radius: widget.cardParameters.circleAvatarRadius!=null?widget.cardParameters.circleAvatarRadius:15,
                  ):
                  Image.network( widget.cardParameters.urlImage!='null'?
                  widget.cardParameters.urlImage:'https://fujifilm-x.com/wp-content/uploads/2019/08/xc16-50mmf35-56-ois-2_sample-images02.jpg',
                  height: widget.cardParameters.imgaeHeight!=null?widget.cardParameters.imgaeHeight:100,
                  width:  widget.cardParameters.imageWidth!=null?widget.cardParameters.imageWidth:100,
                  ),
                )
                ,
                //details
                Card(
                  color: widget.cardParameters.backgroundColorInnerCard??Colors.white,
                  elevation: widget.cardParameters.elevationInnerCard!=null?widget.cardParameters.elevationInnerCard:2,
                  shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(widget.cardParameters.borderRadius!=null?widget.cardParameters.borderRadius:10)),
                  child: Padding(
                    padding: const EdgeInsets.all(4.0),
                    child: Column(
                      crossAxisAlignment: CrossAxisAlignment.start,
                      mainAxisSize: MainAxisSize.min,
                      children: [
                        const SizedBox(height: 8),
                        for(int i =0; i<widget.cardParameters.items.length;i++)
                          for(var key in widget.cardParameters.items[i].keys)
                            details(
                                text: key,
                                icon: widget.cardParameters.items[i][key],
                                iconColor: widget.cardParameters.iconColor,
                                textColor: widget.cardParameters.textColor,
                                fontSize: widget.cardParameters.fontSize,
                                iconSize:  widget.cardParameters.iconSize
                            ),
                        SizedBox(height: widget.cardParameters.heightbetweenTextDescription!=null?widget.cardParameters.heightbetweenTextDescription:8),
                        if(widget.cardParameters.descriptionText!="null")
                          Padding(
                            padding:  EdgeInsets.fromLTRB(
                                widget.cardParameters.descriptionTextPaddingLeft??0,
                                widget.cardParameters.descriptionTextPaddingTop??0,
                                widget.cardParameters.descriptionTextPaddingRight??0,
                                widget.cardParameters.descriptionTextPaddingBoottom??0,
                            ),
                            child: Row(
                              mainAxisAlignment: MainAxisAlignment.start,
                              crossAxisAlignment: CrossAxisAlignment.center,
                              children: [
                             Text(widget.cardParameters.descriptionText,style: TextStyle(fontSize: widget.cardParameters.descriptionTextFontSize!=null?widget.cardParameters.descriptionTextFontSize:10,
                               color: widget.cardParameters.descriptionTextColor??Colors.white
                             ),)
                              ],
                            ),
                          ),

                      ],
                    ),
                  ),
                )
              ],
            ):
            (widget.cardParameters.imgePostition=="Down")?
            Column(
              children: [
                Card(
                  color: widget.cardParameters.backgroundColorInnerCard??Colors.white,
                  elevation: widget.cardParameters.elevationInnerCard!=null?widget.cardParameters.elevationInnerCard:2,
                  shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(widget.cardParameters.borderRadius!=null?widget.cardParameters.borderRadius:10)),
                  child: Padding(
                    padding: const EdgeInsets.all(4.0),
                    child: Column(
                      crossAxisAlignment: CrossAxisAlignment.start,
                      mainAxisSize: MainAxisSize.min,
                      children: [
                        const SizedBox(height: 8),
                        for(int i =0; i<widget.cardParameters.items.length;i++)
                          for(var key in widget.cardParameters.items[i].keys)
                            details(
                                text: key,
                                icon: widget.cardParameters.items[i][key],
                                iconColor: widget.cardParameters.iconColor,
                                textColor: widget.cardParameters.textColor,
                                fontSize: widget.cardParameters.fontSize,
                                iconSize:  widget.cardParameters.iconSize
                            ),
                        SizedBox(height: widget.cardParameters.heightbetweenTextDescription!=null?widget.cardParameters.heightbetweenTextDescription:8),
                        if(widget.cardParameters.descriptionText!="null")
                          Padding(
                            padding:  EdgeInsets.fromLTRB(
                              widget.cardParameters.descriptionTextPaddingLeft??0,
                              widget.cardParameters.descriptionTextPaddingTop??0,
                              widget.cardParameters.descriptionTextPaddingRight??0,
                              widget.cardParameters.descriptionTextPaddingBoottom??0,
                            ),
                            child: Row(
                              mainAxisAlignment: MainAxisAlignment.start,
                              crossAxisAlignment: CrossAxisAlignment.center,
                              children: [
                                Text(widget.cardParameters.descriptionText,style: TextStyle(fontSize: widget.cardParameters.descriptionTextFontSize!=null?widget.cardParameters.descriptionTextFontSize:10,
                                    color: widget.cardParameters.descriptionTextColor??Colors.white
                                ),)
                              ],
                            ),
                          ),
                      ],
                    ),
                  ),
                ),
                Padding(
                  padding:  EdgeInsets.fromLTRB(
                    widget.cardParameters.imagePaddingLeft!=null? widget.cardParameters.imagePaddingLeft:0,
                    widget.cardParameters.imagePaddingTop!=null? widget.cardParameters.imagePaddingTop:0,
                    widget.cardParameters.imagePaddingRight!=null? widget.cardParameters.imagePaddingRight:0,
                    widget.cardParameters.imagePaddingBoottom!=null? widget.cardParameters.imagePaddingBoottom:0,
                  ),
                  child: (widget.cardParameters.cirleAvatar)?
                  CircleAvatar(
                    backgroundImage: NetworkImage( widget.cardParameters.urlImage!='null'?
                    widget.cardParameters.urlImage:'https://fujifilm-x.com/wp-content/uploads/2019/08/xc16-50mmf35-56-ois-2_sample-images02.jpg'),
                    radius: widget.cardParameters.circleAvatarRadius!=null?widget.cardParameters.circleAvatarRadius:15,
                  ):
                  Image.network( widget.cardParameters.urlImage!='null'?
                  widget.cardParameters.urlImage:'https://fujifilm-x.com/wp-content/uploads/2019/08/xc16-50mmf35-56-ois-2_sample-images02.jpg',
                    height: widget.cardParameters.imgaeHeight!=null?widget.cardParameters.imgaeHeight:100,
                    width:  widget.cardParameters.imageWidth!=null?widget.cardParameters.imageWidth:100,
                  ),
                )
                //details

              ],
            ):
            (widget.cardParameters.imgePostition=="Left")?
            Row(
              children: [

                Expanded(flex: widget.cardParameters.flexImage!=null? widget.cardParameters.flexImage:1,
                child:
                Padding(
                  padding:  EdgeInsets.fromLTRB(
                    widget.cardParameters.imagePaddingLeft!=null? widget.cardParameters.imagePaddingLeft:0,
                    widget.cardParameters.imagePaddingTop!=null? widget.cardParameters.imagePaddingTop:0,
                    widget.cardParameters.imagePaddingRight!=null? widget.cardParameters.imagePaddingRight:0,
                    widget.cardParameters.imagePaddingBoottom!=null? widget.cardParameters.imagePaddingBoottom:0,
                  ),
                  child: (widget.cardParameters.cirleAvatar)?
                  CircleAvatar(
                    backgroundImage: NetworkImage( widget.cardParameters.urlImage!='null'?
                    widget.cardParameters.urlImage:'https://fujifilm-x.com/wp-content/uploads/2019/08/xc16-50mmf35-56-ois-2_sample-images02.jpg'),
                    radius: widget.cardParameters.circleAvatarRadius!=null?widget.cardParameters.circleAvatarRadius:15,
                  ):
                  Image.network( widget.cardParameters.urlImage!='null'?
                  widget.cardParameters.urlImage:'https://fujifilm-x.com/wp-content/uploads/2019/08/xc16-50mmf35-56-ois-2_sample-images02.jpg',
                    height: widget.cardParameters.imgaeHeight!=null?widget.cardParameters.imgaeHeight:100,
                    width:  widget.cardParameters.imageWidth!=null?widget.cardParameters.imageWidth:100,
                  ),
                )
                ),
               //details
               Expanded(
                 flex: widget.cardParameters.flexText!=null?widget.cardParameters.flexText:4,
                 child: Card(
                   color: widget.cardParameters.backgroundColorInnerCard??Colors.white,
                   elevation: widget.cardParameters.elevationInnerCard!=null?widget.cardParameters.elevationInnerCard:2,
                   shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(widget.cardParameters.borderRadius!=null?widget.cardParameters.borderRadius:10)),
                   child: Padding(
                     padding: const EdgeInsets.all(4.0),
                     child: Column(
                       crossAxisAlignment: CrossAxisAlignment.start,
                       mainAxisSize: MainAxisSize.min,
                       children: [
                         const SizedBox(height: 8),
                         for(int i =0; i<widget.cardParameters.items.length;i++)
                           for(var key in widget.cardParameters.items[i].keys)
                             details(
                                 text: key,
                                 icon: widget.cardParameters.items[i][key],
                                 iconColor: widget.cardParameters.iconColor,
                                 textColor: widget.cardParameters.textColor,
                                 fontSize: widget.cardParameters.fontSize,
                                 iconSize:  widget.cardParameters.iconSize
                             ),
                         SizedBox(height: widget.cardParameters.heightbetweenTextDescription!=null?widget.cardParameters.heightbetweenTextDescription:8),
                         if(widget.cardParameters.descriptionText!="null")
                           Padding(
                             padding:  EdgeInsets.fromLTRB(
                               widget.cardParameters.descriptionTextPaddingLeft??0,
                               widget.cardParameters.descriptionTextPaddingTop??0,
                               widget.cardParameters.descriptionTextPaddingRight??0,
                               widget.cardParameters.descriptionTextPaddingBoottom??0,
                             ),
                             child: Row(
                               mainAxisAlignment: MainAxisAlignment.start,
                               crossAxisAlignment: CrossAxisAlignment.center,
                               children: [
                                 Text(widget.cardParameters.descriptionText,style: TextStyle(fontSize: widget.cardParameters.descriptionTextFontSize!=null?widget.cardParameters.descriptionTextFontSize:10,
                                     color: widget.cardParameters.descriptionTextColor??Colors.white
                                 ),)
                               ],
                             ),
                           ),
                       ],
                     ),
                   ),
                 ),
               )
              ],
            ):
            Row(
              children: [
                //details
                Expanded(
                  flex: widget.cardParameters.flexText!=null?widget.cardParameters.flexText:4,
                  child: Card(
                    color: widget.cardParameters.backgroundColorInnerCard??Colors.white,
                    elevation: widget.cardParameters.elevation!=null?widget.cardParameters.elevation:2,
                    shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(widget.cardParameters.borderRadius!=null?widget.cardParameters.borderRadius:10)),
                    child: Padding(
                      padding: const EdgeInsets.all(4.0),
                      child: Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        mainAxisSize: MainAxisSize.min,
                        children: [
                          const SizedBox(height: 8),
                          for(int i =0; i<widget.cardParameters.items.length;i++)
                            for(var key in widget.cardParameters.items[i].keys)
                              details(
                                  text: key,
                                  icon: widget.cardParameters.items[i][key],
                                  iconColor: widget.cardParameters.iconColor,
                                  textColor: widget.cardParameters.textColor,
                                  fontSize: widget.cardParameters.fontSize,
                                  iconSize:  widget.cardParameters.iconSize
                              ),
                          SizedBox(height: widget.cardParameters.heightbetweenTextDescription!=null?widget.cardParameters.heightbetweenTextDescription:8),
                          if(widget.cardParameters.descriptionText!="null")
                            Padding(
                              padding:  EdgeInsets.fromLTRB(
                                widget.cardParameters.descriptionTextPaddingLeft??0,
                                widget.cardParameters.descriptionTextPaddingTop??0,
                                widget.cardParameters.descriptionTextPaddingRight??0,
                                widget.cardParameters.descriptionTextPaddingBoottom??0,
                              ),
                              child: Row(
                                mainAxisAlignment: MainAxisAlignment.start,
                                crossAxisAlignment: CrossAxisAlignment.center,
                                children: [
                                  Text(widget.cardParameters.descriptionText,style: TextStyle(fontSize: widget.cardParameters.descriptionTextFontSize!=null?widget.cardParameters.descriptionTextFontSize:10,
                                      color: widget.cardParameters.descriptionTextColor??Colors.white
                                  ),)
                                ],
                              ),
                            ),
                        ],
                      ),
                    ),
                  ),
                ),
                Expanded(flex: widget.cardParameters.flexImage!=null? widget.cardParameters.flexImage:1,
                  child: Padding(
                    padding:  EdgeInsets.fromLTRB(
                      widget.cardParameters.imagePaddingLeft!=null? widget.cardParameters.imagePaddingLeft:0,
                      widget.cardParameters.imagePaddingTop!=null? widget.cardParameters.imagePaddingTop:0,
                      widget.cardParameters.imagePaddingRight!=null? widget.cardParameters.imagePaddingRight:0,
                      widget.cardParameters.imagePaddingBoottom!=null? widget.cardParameters.imagePaddingBoottom:0,
                    ),
                    child: (widget.cardParameters.cirleAvatar)?
                    CircleAvatar(
                      backgroundImage: NetworkImage( widget.cardParameters.urlImage!='null'?
                      widget.cardParameters.urlImage:'https://fujifilm-x.com/wp-content/uploads/2019/08/xc16-50mmf35-56-ois-2_sample-images02.jpg'),
                      radius: widget.cardParameters.circleAvatarRadius!=null?widget.cardParameters.circleAvatarRadius:15,
                    ):
                    Image.network( widget.cardParameters.urlImage!='null'?
                    widget.cardParameters.urlImage:'https://fujifilm-x.com/wp-content/uploads/2019/08/xc16-50mmf35-56-ois-2_sample-images02.jpg',
                      height: widget.cardParameters.imgaeHeight!=null?widget.cardParameters.imgaeHeight:100,
                      width:  widget.cardParameters.imageWidth!=null?widget.cardParameters.imageWidth:100,
                    ),
                  )
                ),

              ],
            )
          )
        ],
      ),
    );
  }
  Widget details({String text , Color iconColor, Color textColor, IconData icon, double fontSize,double iconSize}){
    return (icon!=null ||text!='null')?Column(
      children: [
        SizedBox(height: widget.cardParameters.heightBetweenText!=null?widget.cardParameters.heightBetweenText:6,),
        Padding(
          padding:  EdgeInsets.fromLTRB(
              widget.cardParameters.TextPaddingLeft??0,
              widget.cardParameters.TextPaddingTop??0,
              widget.cardParameters.TextPaddingRight??0,
              widget.cardParameters.TextPaddingBoottom??0
          ),
          child: Row(
            mainAxisAlignment: MainAxisAlignment.start,
            crossAxisAlignment: CrossAxisAlignment.center,
            children: [
              (icon!=null)?Icon(icon,size:iconSize!=null?iconSize:10 ,color: iconColor??Colors.black,):SizedBox.shrink(),
              (icon!=null)?SizedBox(width: 8,):SizedBox.shrink(),
              (text!='null')?Expanded(child: Text(text,style: TextStyle(fontSize: fontSize!=null?fontSize:12,color: textColor??Colors.black),)):SizedBox.shrink(),
            ],
          ),
        ),
        SizedBox(height: widget.cardParameters.heightBetweenText!=null?widget.cardParameters.heightBetweenText:6,),
      ],
    ):SizedBox.shrink();

  }
}
